#!/bin/sh

###
### Package specific configuration
###
PREFIX=/opt/QtPalmtop
PACKAGE=znester
VERSION=7.1-1

SECTION=games
# admin, base, comm, editors, extras, games, graphics, kernel, libs, misc
# net, text, web, x11

DEPENDS=libsdl

LICENSE=GPL

SHORT_DESCRIPTION="Nester NES Emulator"
cat >/tmp/ipkg-longdescription <<EOF
EOF

do_install() {
    mkdir -p $IPKG_PREFIX/bin

    arm-linux-strip src/obj-sdl/nester.elf
    cp -dp src/obj-sdl/nester.elf $IPKG_PREFIX/bin/znester

    #mkdir -p $IPKG_PREFIX/share/zgnuboy/defaultskin
    #cp -dp skin.rc background.bmp $IPKG_PREFIX/share/zgnuboy/defaultskin
}

###
### Site specifix configuration
###
IPKG_ROOT=~/zaurus/ipkg
IPKG_MAINTAINER="AGAWA Koji <kaoru-k@self-core.org>"
IPKG_DISTDIR=~/zaurus/dist
IPKG_ARCHITECTURE=arm

###
###
###
IPKG_PACKAGEDIR=$IPKG_ROOT/$PACKAGE
IPKG_CONTROLDIR=$IPKG_PACKAGEDIR/CONTROL
IPKG_CONTROL=$IPKG_CONTROLDIR/control
IPKG_PREFIX=${IPKG_PACKAGEDIR}${PREFIX}

## clean
rm -rf $IPKG_PACKAGEDIR

## Generate control file
mkdir -p $IPKG_CONTROLDIR
cat >$IPKG_CONTROL <<EOF
Package: ${PACKAGE}
Priority: optional
Section: ${SECTION}
Version: ${VERSION}
Architecture: ${IPKG_ARCHITECTURE}
Maintainer: ${IPKG_MAINTAINER}
Depends: ${DEPENDS}
License: ${LICENSE}
Description: ${SHORT_DESCRIPTION}
EOF
cat /tmp/ipkg-longdescription | sed -e 's/^/ /' >>$IPKG_CONTROL
rm -f /tmp/ipkg-longdescription

## Generate copyright
mkdir -p $IPKG_PREFIX/share/doc/$PACKAGE
case $LICENSE in
    GPL|GPL-2|LGPL|LGPL-2|LGPL-2.1|BSD|Artistic)
	cat /usr/share/common-licenses/$LICENSE >$IPKG_PREFIX/share/doc/$PACKAGE/copyright
	;;
esac

## Install to workdir
do_install

## build ipk
ipkg-build $IPKG_PACKAGEDIR
cp -p ${PACKAGE}_${VERSION}_${IPKG_ARCHITECTURE}.ipk $IPKG_DISTDIR
rm ${PACKAGE}_${VERSION}_${IPKG_ARCHITECTURE}.ipk
